#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define MAX_PLAY_TIMES 10
#define NAME "iT"

void new_answer(int *aa, int *bb, int *cc);
int answer_proc(int new_game);  
void give_guess(int answer, int *num_a, int *num_b);
int guess_proc(int new_game);  

int main(void)
{
   int play_times = 0;
   int get_answer;  // 0: initial, 1: right, -1: stop
   char ch;
   int show_times = 0;
   //
   srand((unsigned)time(NULL));
   //
   printf("? (y (yes) or n (no)) ");
   scanf("%c", &ch);
   //
   if (ch == 'y')
   {
	    show_times = 1;
		printf("= %d\n", show_times);
		guess_proc(1);
		get_answer = answer_proc(1);
		play_times = 1;

		while(play_times < MAX_PLAY_TIMES)
		{
			show_times += 2;
			printf("= %d\n", show_times);
			guess_proc(0);
			if (get_answer == 0)
				get_answer = answer_proc(0);
			play_times++;
		}
   }
   else
   {
		get_answer = answer_proc(1);
	    show_times = 2;
		printf("= %d\n", show_times);
		guess_proc(1);
		play_times = 1;

		while(play_times < MAX_PLAY_TIMES)
		{
			if (get_answer == 0)
				get_answer = answer_proc(0);
			show_times += 2;
			printf("= %d\n", show_times);
			guess_proc(0);
			play_times++;
		}
   }

   if (get_answer == 0)
		answer_proc(2);
   
   return 0;
}

void new_answer(int *aa, int *bb, int *cc)
{
   *aa = rand()%9+1;
   do 
     *bb = rand()%9+1;
   while (*bb == *aa);
   do 
     *cc = rand()%9+1;
   while (*cc == *aa || *cc == *bb);
}

int answer_proc(int new_game)  
{
   static int get_answer = 0; // 0: no, 1: yes
   static int aa=0, bb=0, cc=0;  // answer
   static int answer_times = 0;
   int i, a, b, c, x, j , k;
   //
   // new game
   if (new_game == 1)
   {
	  get_answer = 0;
	  new_answer(&aa, &bb, &cc);
	  answer_times = 0;
   }
   // print the answer
   if (new_game == 2)
   {
      printf("= %d\n", cc*100+bb*10+aa);
	  return get_answer;
   }
   //
   if (get_answer == 0)
   {
	 printf("%s,вq@ХBt0T (ҡG123A_{пJG0):", NAME);
     scanf("%d",&i);
	 answer_times++;
     //
     if (i == 0)
	 {
		get_answer = 1;
		printf("= %d", cc*100+bb*10+aa);
	 }
	 //
	 else
	 {
	    x = i;
		a = x%10;
		x = x/10;
		b = x%10;
		x = x/10;
		c = x%10;
		//
		j = k =0;
		if (a == aa) j++;
		else if (a == bb || a == cc) k++;
		if (b == bb) j++;
		else if (b == aa || b == cc) k++;
		if (c == cc) j++;
		else if (c == aa || c == bb) k++;
		if (j == 3)
		{
			get_answer = 1;
			printf("צ= %dAzqFA= %d\n", answer_times, cc*100+bb*10+aa);
		}
		else
			printf("צ= %dAG=%da%db\n", answer_times, j, k);
	 }
   }  
   //
   return get_answer;
}

int guess_proc(int new_game)  
{
   static int get_answer = 0; 
   static int state = 1;
   int answer=0, num_a, num_b;
   static int i=0,j,answer_a,answer_b,answer_c,used[9]={0},first[3]={0},second[3]={0};

   // i use(randw]LX)  jj  answer_abcqƦr   usedwιLƦr
   // first Ĥ@]Ʀr Kƫ_   second   a+b<2 ]Ʀr Kƫ_
   

   if (new_game)
   {
	  get_answer = 0;
	  state = 1;
   }
   
   
   switch (state)
   {
     case 1:	 
		 

		 do
		 answer_a=rand()%9+1;
		 while
		 (used[0]==answer_a || used[1]==answer_a || used[2]==answer_a || used[3]==answer_a || used[4]==answer_a || used[5]==answer_a || used[6]==answer_a || used[7]==answer_a || used[8]==answer_a  );
		 used[i]=answer_a;
		 first[0]=answer_a;
		 i+=1;		 
		 
		 do
		 answer_b=rand()%9+1;
		 while
		 (used[0]==answer_b || used[1]==answer_b || used[2]==answer_b || used[3]==answer_b || used[4]==answer_b || used[5]==answer_b || used[6]==answer_b || used[7]==answer_b || used[8]==answer_b  );
		 used[i]=answer_b;
		 first[1]=answer_b;
		 i+=1; 

		 do
		 answer_c=rand()%9+1;
		 while
		 (used[0]==answer_c || used[1]==answer_c || used[2]==answer_c || used[3]==answer_c || used[4]==answer_c || used[5]==answer_c || used[6]==answer_c || used[7]==answer_c || used[8]==answer_c  );
		 used[i]=answer_c;
		 first[2]=answer_c;
		 i+=1;	 
	 
		 
		 answer = answer_a*100+answer_b*10+answer_c;		 			 
		 give_guess(answer, &num_a, &num_b);

			 if (num_a == 0 && num_b == 3){  
				 state = 2;}
			 if (num_a == 1 && num_b == 2){
				 state = 4;}
			 if (num_a == 1 && num_b == 1){
				 state = 7;}
			 if (num_a == 2 && num_b == 0){
				 state = 15;}
			 if (num_a == 0 && num_b == 2){
				 state = 20;}			
			 if (num_a == 1 && num_b == 0){
				 state = 23;}
			 if (num_a == 0 && num_b == 1){
				 state = 40;}			 
			 if (num_a == 0 && num_b == 0){
				 state = 1;}
				
	         break;	   
	   
	 //abc   3BA
     
	 case 2: answer = answer_b*100+answer_c*10+answer_a;     //bca
			 give_guess(answer, &num_a, &num_b);
			 printf("state is %d\n",state);
			 state = 3;	 			 
	         break;
     
	 case 3: answer = answer_c*100+answer_a*10+answer_b;     //cab
			 give_guess(answer, &num_a, &num_b);
			 printf("state is %d\n",state);
	         break;
	
	//abc   1a2bA
			 
	 case 4: answer = answer_a*100+answer_c*10+answer_b;     //acb
			 give_guess(answer, &num_a, &num_b);
			 printf("state is %d\n",state);
			 state=5;
			 break;
	 
	 case 5: answer = answer_b*100+answer_a*10+answer_c;     //bac
			 give_guess(answer, &num_a, &num_b);
			 printf("state is %d\n",state);
			 state=6;
			 break;

	 case 6: answer = answer_b*100+answer_a*10+answer_c;     //cba
			 give_guess(answer, &num_a, &num_b);
			 printf("state is %d\n",state);
			 break;
	
	//abc    1a1bA

    //]ab

	 case 7:    //a(c)b

		 
		 do
		 answer_c=rand()%9+1;
		 while
		 (used[0]==answer_c || used[1]==answer_c || used[2]==answer_c || used[3]==answer_c || used[4]==answer_c || used[5]==answer_c || used[6]==answer_c || used[7]==answer_c || used[8]==answer_c  );
		 
		 
		 answer= answer_a*100+answer_c*10+answer_b;
		 give_guess(answer, &num_a, &num_b);
		 		 
		 if (num_a == 0 && num_b == 3){   
			 state = 2;
		     used[i]=answer_c;		 
		     i+=1;}
		 else if (num_a == 2 && num_b == 0){
			 state = 7;
		     used[i]=answer_c;		 
		     i+=1;}
		 else if (num_a == 0 && num_b == 2){
			 used[i]=answer_c;		 
		     i+=1;    
			 state = 8;}
		 else {

			 state =9;
		 }

		 break;


	 case 8:    //(c)ba

		 	 
		 do
		 answer_c=rand()%9+1;
		 while
		 (used[0]==answer_c || used[1]==answer_c || used[2]==answer_c || used[3]==answer_c || used[4]==answer_c || used[5]==answer_c || used[6]==answer_c || used[7]==answer_c || used[8]==answer_c  );
		 used[i]=answer_c;		 
		 i+=1;
		 
		 answer= answer_c*100+answer_b*10+answer_a;
		 give_guess(answer, &num_a, &num_b);
		 		 
		 if (num_a == 0 && num_b == 3){   
				 state = 2;}
		 if (num_a == 2 && num_b == 0){
			     state = 8;}
		 break;

	//]ac

     case 9:    //ac(d)

		 
		 answer_c=first[2];
		 do
		 answer_b=rand()%9+1;
		 while
		 (used[0]==answer_b || used[1]==answer_b || used[2]==answer_b || used[3]==answer_b || used[4]==answer_b || used[5]==answer_b || used[6]==answer_b || used[7]==answer_b || used[8]==answer_b  );

		 
		 answer= answer_a*100+answer_c*10+answer_b;
		 give_guess(answer, &num_a, &num_b);
		 		 
		 if (num_a == 0 && num_b == 3){   
			 used[i]=answer_b;		 
		     i+=1;	 
			 state = 2;}
		 else if (num_a == 2 && num_b == 0){
			 used[i]=answer_b;		 
		     i+=1;
			 state = 9;}
		 else if (num_a == 0 && num_b == 2){
			 used[i]=answer_b;		 
		     i+=1;
			 state = 10;}
		 else{
			 state =11;
		 }

		 break;

	case 10:    //(c)ac

		  
		 do
		 answer_b=rand()%9+1;
		 while
		 (used[0]==answer_b || used[1]==answer_b || used[2]==answer_b || used[3]==answer_b || used[4]==answer_b || used[5]==answer_b || used[6]==answer_b || used[7]==answer_b || used[8]==answer_b  );
		 used[i]=answer_b;		 
		 i+=1;
		 
		 answer= answer_c*100+answer_b*10+answer_a;
		 give_guess(answer, &num_a, &num_b);
		 		 
		 if (num_a == 0 && num_b == 3){   
				 state = 2;}
		 if (num_a == 2 && num_b == 0){
			     state = 10;}
		 break;

	//]bc

	case 11:    //b(d)c
		
		 
		 answer_b=first[1];
		 do
		 answer_a=rand()%9+1;
		 while
		 (used[0]==answer_a || used[1]==answer_a || used[2]==answer_a || used[3]==answer_a || used[4]==answer_a || used[5]==answer_a || used[6]==answer_a || used[7]==answer_a || used[8]==answer_a  );
		 used[i]=answer_a;		 
		 i+=1;
		 
		 answer= answer_b*100+answer_a*10+answer_c;
		 give_guess(answer, &num_a, &num_b);
		 		 
		 if (num_a == 0 && num_b == 3){   
				 state = 2;}
		 if (num_a == 2 && num_b == 0){
			     state = 11;}
		 if (num_a == 0 && num_b == 2){
			     state = 12;}
		 break;

	case 12:    //cb(d)

	    
		 
		 do
		 answer_a=rand()%9+1;
		 while
		 (used[0]==answer_a || used[1]==answer_a || used[2]==answer_a || used[3]==answer_a || used[4]==answer_a || used[5]==answer_a || used[6]==answer_a || used[7]==answer_a || used[8]==answer_a  );
		 used[i]=answer_a;		 
		 i+=1;
		 
		 answer= answer_c*100+answer_b*10+answer_a;
		 give_guess(answer, &num_a, &num_b);
		 		 
		 if (num_a == 0 && num_b == 3){   
				 state = 2;}
		 if (num_a == 2 && num_b == 0){
			     state = 12;}		 
		 break;

	   

   //abc  2a0bA 

   //]cO
    case 15:

       
		 do
		 answer_c=rand()%9+1;
		 while
		 (used[0]==answer_c || used[1]==answer_c || used[2]==answer_c || used[3]==answer_c || used[4]==answer_c || used[5]==answer_c || used[6]==answer_c || used[7]==answer_c || used[8]==answer_c  );
		 used[i]=answer_c;		 
		 i+=1;
		 
		 answer= answer_a*100+answer_b*10+answer_c;
		 give_guess(answer, &num_a, &num_b);

		  if (num_a == 2 && num_b == 0){   
				 state = 15;}
		  else{   
				 state = 16;}
		  break;

	//]bO jSn~
	case 16:
         
		 answer_c=first[2];

         do
		 answer_b=rand()%9+1;
		 while
		 (used[0]==answer_b || used[1]==answer_b || used[2]==answer_b || used[3]==answer_b || used[4]==answer_b || used[5]==answer_b || used[6]==answer_b || used[7]==answer_b || used[8]==answer_b  );
		 used[i]=answer_b;		 
		 i+=1; 
		 
		 answer= answer_a*100+answer_b*10+answer_c;
		 give_guess(answer, &num_a, &num_b);

		  if (num_a == 2 && num_b == 0){   
				 state = 16;}
		  else{   
				 state = 18;}
		  break;


	//]aO jSn~
	case 18:
         
		 answer_b=first[1];

         do
		 answer_a=rand()%9+1;
		 while
		 (used[0]==answer_a || used[1]==answer_a || used[2]==answer_a || used[3]==answer_a || used[4]==answer_a || used[5]==answer_a || used[6]==answer_a || used[7]==answer_a || used[8]==answer_a  );
		 used[i]=answer_a;		 
		 i+=1; 
		 
		 answer= answer_a*100+answer_b*10+answer_c;
		 give_guess(answer, &num_a, &num_b);
		 state = 18;
		 break;


   //abc  0a2bA 

   //]cO
    case 20:

         
		 do
		 answer_c=rand()%9+1;
		 while
		 (used[0]==answer_c || used[1]==answer_c || used[2]==answer_c || used[3]==answer_c || used[4]==answer_c || used[5]==answer_c || used[6]==answer_c || used[7]==answer_c || used[8]==answer_c  );
		 used[i]=answer_c;		 
		 i+=1;
		 
		 answer= answer_a*100+answer_b*10+answer_c;
		 give_guess(answer, &num_a, &num_b);

		  if (num_a == 0 && num_b == 2){   
				 state = 20;}
		  else if (num_a == 0 && num_b == 3){   
				 state = 2;}
		  else {   
				 state = 21;}
		  
		  break;

	//]bO

    case 21:

        
		 answer_c=first[2];

		 do
		 answer_b=rand()%9+1;
		 while
		 (used[0]==answer_b || used[1]==answer_b || used[2]==answer_b || used[3]==answer_b || used[4]==answer_b || used[5]==answer_b || used[6]==answer_b || used[7]==answer_b || used[8]==answer_b  );
		 used[i]=answer_b;		 
		 i+=1; 
		 
		 answer= answer_a*100+answer_b*10+answer_c;
		 give_guess(answer, &num_a, &num_b);

		  if (num_a == 0 && num_b == 2){   
				 state = 21;}
		  else if (num_a == 0 && num_b == 3){   
				 state = 2;}
		  else {   
				 state = 22;}		  
		  break;

     //]aO

	 case 22:

        
		 answer_b=first[1];

		 
		 
		 
		 answer= answer_a*100+answer_b*10+answer_c;
		 give_guess(answer, &num_a, &num_b);

		  if (num_a == 0 && num_b == 2){   
				 state = 22;}
		  else {   
				 state = 2;}		  
		  break;

	//abc  1a0b  A
	
    //bc

	 case 23:

				 		 
		 do
		 answer_b=rand()%9+1;
		 while
		 (used[0]==answer_b || used[1]==answer_b || used[2]==answer_b || used[3]==answer_b || used[4]==answer_b || used[5]==answer_b || used[6]==answer_b || used[7]==answer_b || used[8]==answer_b  );
		 used[i]=answer_b;
		 second[1]=answer_b;
		 i+=1;

		 do
		 answer_c=rand()%9+1;
		 while
		 (used[0]==answer_c || used[1]==answer_c || used[2]==answer_c || used[3]==answer_c || used[4]==answer_c || used[5]==answer_c || used[6]==answer_c || used[7]==answer_c || used[8]==answer_c  );
		 used[i]=answer_c;
		 second[2]=answer_c;
		 i+=1;	 
		 
		 answer= answer_a*100+answer_b*10+answer_c;
		 give_guess(answer, &num_a, &num_b);

		     if (num_a == 1 && num_b == 2){
				 state = 4;}
			 else if (num_a == 1 && num_b == 1){  
				 state = 24;}
			 else if (num_a == 2 && num_b == 0){  
				 state = 26;}			 
			 else if (num_a == 1 && num_b == 0){  
				 state = 52;}
			 else if (num_a == 0 && num_b == 1){
				 state = 28;}			 
			 else if (num_a == 0 && num_b == 0){
				 state = 33;}
		break;

	

     case 24:

		 do
		 answer_c=rand()%9+1;
		 while
		 (used[0]==answer_c || used[1]==answer_c || used[2]==answer_c || used[3]==answer_c || used[4]==answer_c || used[5]==answer_c || used[6]==answer_c || used[7]==answer_c || used[8]==answer_c  );
		 second[2]=answer_c;
		 i+=1;	 		 

		 answer= answer_a*100+answer_c*10+answer_b;
		 give_guess(answer, &num_a, &num_b);

		 if ((num_a == 2 && num_b == 0) || (num_a == 2 && num_b == 1)){
			     used[i]=answer_c;
				 state = 24;}
		 else{
			 state=25;}
		 break;	
	 
	 case 25:

		 
		 answer_c=second[2];

		 do
		 answer_b=rand()%9+1;
		 while
		 (used[0]==answer_b || used[1]==answer_b || used[2]==answer_b || used[3]==answer_b || used[4]==answer_b || used[5]==answer_b || used[6]==answer_b || used[7]==answer_b || used[8]==answer_b  );
		 used[i]=answer_b;
		 second[1]=answer_b;
		 i+=1;		 	 		 

		 answer= answer_a*100+answer_c*10+answer_b;
		 give_guess(answer, &num_a, &num_b);
		 state=25;
		 break;

    //]cO
    case 26:

        
		 do
		 answer_c=rand()%9+1;
		 while
		 (used[0]==answer_c || used[1]==answer_c || used[2]==answer_c || used[3]==answer_c || used[4]==answer_c || used[5]==answer_c || used[6]==answer_c || used[7]==answer_c || used[8]==answer_c  );
		 used[i]=answer_c;		 
		 i+=1;
		 
		 answer= answer_a*100+answer_b*10+answer_c;
		 give_guess(answer, &num_a, &num_b);

		  if (num_a == 2 && num_b == 0){   
				 state = 26;}
		  else{   
				 state = 27;}
		  break;

	//]bO jSn~
	case 27:
        
		 answer_c=second[2];

         do
		 answer_b=rand()%9+1;
		 while
		 (used[0]==answer_b || used[1]==answer_b || used[2]==answer_b || used[3]==answer_b || used[4]==answer_b || used[5]==answer_b || used[6]==answer_b || used[7]==answer_b || used[8]==answer_b  );
		 used[i]=answer_b;		 
		 i+=1; 
		 
		 answer= answer_a*100+answer_b*10+answer_c;
		 give_guess(answer, &num_a, &num_b);
		 state=27;
		 break;

	case 28:
        
		 answer_b=first[1]; 	 
		 
		 answer= answer_a*100+answer_b*10+answer_c;
		 give_guess(answer, &num_a, &num_b);
		 if(num_a == 1 && num_b == 1){
			 state=29;
		 }else if (num_a == 0 && num_b == 1){
			 state=30;
		 }else{ state=31;}
		 
		 break;

	case 29:
         
		
		 answer_b=first[1]; 
		 
		 do
		 answer_a=rand()%9+1;
		 while
		 (used[0]==answer_a || used[1]==answer_a || used[2]==answer_a || used[3]==answer_a || used[4]==answer_a || used[5]==answer_a || used[6]==answer_a || used[7]==answer_a || used[8]==answer_a  );
		 used[i]=answer_a;
		 i+=1;
		 
		 answer= answer_c*100+answer_b*10+answer_a;
		 give_guess(answer, &num_a, &num_b);
		 state=29;		 		 
		 break;
	
	case 30:
         
		
		 answer_c=first[2];
		 answer_b=second[2];  //c'

		 		 
		 answer= answer_a*100+answer_b*10+answer_c;
		 give_guess(answer, &num_a, &num_b);
		 if(num_a == 2 && num_b == 0){
			 state=32;
		 }else{
			 state=33;
		 }	 
		 break;

	case 31: 
        
		
		 answer_c=first[2];
		 answer_b=second[1];

		 do
		 answer_a=rand()%9+1;
		 while
		 (used[0]==answer_a || used[1]==answer_a || used[2]==answer_a || used[3]==answer_a || used[4]==answer_a || used[5]==answer_a || used[6]==answer_a || used[7]==answer_a || used[8]==answer_a  );
		 used[i]=answer_a;
		 i+=1;
		 
		 answer= answer_b*100+answer_a*10+answer_c;
		 give_guess(answer, &num_a, &num_b);
		 state=31;		 
		 break;

	case 32:

	
		do
		answer_a=rand()%9+1;
	    while
		(used[0]==answer_a || used[1]==answer_a || used[2]==answer_a || used[3]==answer_a || used[4]==answer_a || used[5]==answer_a || used[6]==answer_a || used[7]==answer_a || used[8]==answer_a  );
	    used[i]=answer_a;
		i+=1;

		answer= answer_b*100+answer_a*10+answer_c;
		give_guess(answer, &num_a, &num_b);
		state=32;
		break;

	case 33:

	
		answer_b=first[1];	

		answer= answer_a*100+answer_b*10+answer_c;
		give_guess(answer, &num_a, &num_b);
		if(num_a == 1 && num_b == 0){
			state=34;
		}else{
			state=37;
		}		
		break;

	case 34:

	
		answer_b=first[1];


		do
		answer_a=rand()%9+1;
		while
		(used[0]==answer_a || used[1]==answer_a || used[2]==answer_a || used[3]==answer_a || used[4]==answer_a || used[5]==answer_a || used[6]==answer_a || used[7]==answer_a || used[8]==answer_a  );
		used[i]=answer_a;
		i+=1;
			

		answer= answer_a*100+answer_b*10+answer_c;
		give_guess(answer, &num_a, &num_b);
		if(num_a == 1 && num_b == 1){
			state=35;
		}else if(num_a == 1 && num_b == 0){
			state=34;
		}else if(num_a == 2 && num_b == 0){
			state=36;
		}
		break;

	case 35:

		

		do
	    answer_c=rand()%9+1;
		while
		(used[0]==answer_c || used[1]==answer_c || used[2]==answer_c || used[3]==answer_c || used[4]==answer_c || used[5]==answer_c || used[6]==answer_c || used[7]==answer_c || used[8]==answer_c  );
		second[2]=answer_c;
		i+=1;

		answer= answer_c*100+answer_b*10+answer_a;
		give_guess(answer, &num_a, &num_b);
		state=35;
		break;

	case 36:

	
		do
	    answer_c=rand()%9+1;
		while
		(used[0]==answer_c || used[1]==answer_c || used[2]==answer_c || used[3]==answer_c || used[4]==answer_c || used[5]==answer_c || used[6]==answer_c || used[7]==answer_c || used[8]==answer_c  );
		second[2]=answer_c;
		i+=1;

		answer= answer_a*100+answer_b*10+answer_c;
		give_guess(answer, &num_a, &num_b);
		state=36;
		break;

	case 37:

	
		answer_c=first[2];
		do
		answer_a=rand()%9+1;
		while
		(used[0]==answer_a || used[1]==answer_a || used[2]==answer_a || used[3]==answer_a || used[4]==answer_a || used[5]==answer_a || used[6]==answer_a || used[7]==answer_a || used[8]==answer_a  );
		used[i]=answer_a;
		i+=1;

		answer= answer_a*100+answer_b*10+answer_c;
		give_guess(answer, &num_a, &num_b);
		if(num_a == 1 && num_b == 1){
			state=38;
		}else if(num_a == 1 && num_b == 0){
			state=37;
		}else if(num_a == 2 && num_b == 0){
			state=39;
		}
		break;

	case 38:

		do
		answer_b=rand()%9+1;
		while
		(used[0]==answer_b || used[1]==answer_b || used[2]==answer_b || used[3]==answer_b || used[4]==answer_b || used[5]==answer_b || used[6]==answer_b || used[7]==answer_b || used[8]==answer_b  );
		used[i]=answer_b;		 
		i+=1;		

		answer= answer_b*100+answer_a*10+answer_c;
		give_guess(answer, &num_a, &num_b);
		state=38;
		break;

	case 39:

		do
		answer_b=rand()%9+1;
		while
		(used[0]==answer_b || used[1]==answer_b || used[2]==answer_b || used[3]==answer_b || used[4]==answer_b || used[5]==answer_b || used[6]==answer_b || used[7]==answer_b || used[8]==answer_b  );
		used[i]=answer_b;		 
		i+=1;		

		answer= answer_a*100+answer_b*10+answer_c;
		give_guess(answer, &num_a, &num_b);
		state=39;
		break;

	//abc  0a1b  A
	
    //bc

	 case 40:

			 		 
		 do
		 answer_b=rand()%9+1;
		 while
		 (used[0]==answer_b || used[1]==answer_b || used[2]==answer_b || used[3]==answer_b || used[4]==answer_b || used[5]==answer_b || used[6]==answer_b || used[7]==answer_b || used[8]==answer_b  );
		 used[i]=answer_b;
		 second[1]=answer_b;
		 i+=1;

		 do
		 answer_c=rand()%9+1;
		 while
		 (used[0]==answer_c || used[1]==answer_c || used[2]==answer_c || used[3]==answer_c || used[4]==answer_c || used[5]==answer_c || used[6]==answer_c || used[7]==answer_c || used[8]==answer_c  );
		 used[i]=answer_c;
		 second[2]=answer_c;
		 i+=1;	 
		 
		 answer= answer_a*100+answer_b*10+answer_c;
		 give_guess(answer, &num_a, &num_b);

		     if (num_a == 0 && num_b == 3){
				 state = 2;}		 
		     else if (num_a == 1 && num_b == 2){
				 state = 4;}
			 else if (num_a == 1 && num_b == 1){  
				 state = 41;}
			 else if (num_a == 2 && num_b == 0){  
				 state = 15;}
			 else if (num_a == 0 && num_b == 2){  
				 state = 47;}			 
			 else if (num_a == 1 && num_b == 0){  
				 state = 55;}
			 else if (num_a == 0 && num_b == 1){
				 state = 1;}			 
			 else if (num_a == 0 && num_b == 0){
				 state = 40;}
		break;

	 case 41:

	
		 answer_b=first[1];

		 answer= answer_b*100+answer_a*10+answer_c;
		 give_guess(answer, &num_a, &num_b);

		 if (num_a == 2 && num_b == 0){
				 state = 42;}		 
		 else if (num_a == 1 && num_b == 0){
				 state = 43;}
	     else if (num_a == 0 && num_b == 1){  
				 state = 44;}
		 break;


     case 42:


		 do
		 answer_b=rand()%9+1;
		 while
		 (used[0]==answer_b || used[1]==answer_b || used[2]==answer_b || used[3]==answer_b || used[4]==answer_b || used[5]==answer_b || used[6]==answer_b || used[7]==answer_b || used[8]==answer_b  );
		 used[i]=answer_b;
		 i+=1;		 

		 answer= answer_b*100+answer_a*10+answer_c;
		 give_guess(answer, &num_a, &num_b);
		 state = 42;
		 break;

	 case 43:

	
		  answer_b=second[1];

		  do
		  answer_a=rand()%9+1;
		  while
		  (used[0]==answer_a || used[1]==answer_a || used[2]==answer_a || used[3]==answer_a || used[4]==answer_a || used[5]==answer_a || used[6]==answer_a || used[7]==answer_a || used[8]==answer_a  );
		  used[i]=answer_a;
		  i+=1;

		  answer= answer_b*100+answer_a*10+answer_c;
		  give_guess(answer, &num_a, &num_b);
		  state = 43;
		  break;

	 case 44:

	
		  answer_b=second[1];
		  answer_c=first[2];

		  answer= answer_c*100+answer_b*10+answer_a;
		  give_guess(answer, &num_a, &num_b);

		  if (num_a == 2 && num_b == 0){
				 state = 45;}		 
		 else {
				 state = 46;}
		 break;

	 case 45:

	
		  do
		  answer_c=rand()%9+1;
		  while
		  (used[0]==answer_c || used[1]==answer_c || used[2]==answer_c || used[3]==answer_c || used[4]==answer_c || used[5]==answer_c || used[6]==answer_c || used[7]==answer_c || used[8]==answer_c  );
		  used[i]=answer_c;
		  i+=1;
		  
		  answer= answer_c*100+answer_b*10+answer_a;
		  give_guess(answer, &num_a, &num_b);
		  state = 45;
		  break;

	 case 46:

		  answer_c=second[2];
		 

		  do
		  answer_a=rand()%9+1;
		  while
		  (used[0]==answer_a || used[1]==answer_a || used[2]==answer_a || used[3]==answer_a || used[4]==answer_a || used[5]==answer_a || used[6]==answer_a || used[7]==answer_a || used[8]==answer_a  );
		  used[i]=answer_a;
		  i+=1;

		  answer= answer_c*100+answer_b*10+answer_a;
		  give_guess(answer, &num_a, &num_b);
		  state = 46;
		  break;

	 case 47:

		 answer_b=first[1];
		 
		 answer= answer_a*100+answer_b*10+answer_c;
		 give_guess(answer, &num_a, &num_b);

		 if (num_a == 0 && num_b == 2){
				 state = 48;}		 
		 else {
				 state = 49;}
		 break;

	 case 48:

		

		 do
		 answer_b=rand()%9+1;
		 while
		 (used[0]==answer_b || used[1]==answer_b || used[2]==answer_b || used[3]==answer_b || used[4]==answer_b || used[5]==answer_b || used[6]==answer_b || used[7]==answer_b || used[8]==answer_b  );
		 used[i]=answer_b;
		 i+=1;
		 
		 answer= answer_a*100+answer_b*10+answer_c;
		 give_guess(answer, &num_a, &num_b);
		 state=48;
		 break;

	 case 49:

		 answer_c=first[2];

		 answer= answer_a*100+answer_b*10+answer_c;
		 give_guess(answer, &num_a, &num_b);

		 if (num_a == 0 && num_b == 2){
				 state = 50;}		 
		 else {
				 state = 51;}
		 break;

	case 50:

		 answer_b=second[1];

		 do
		 answer_c=rand()%9+1;
		 while
		 (used[0]==answer_c || used[1]==answer_c || used[2]==answer_c || used[3]==answer_c || used[4]==answer_c || used[5]==answer_c || used[6]==answer_c || used[7]==answer_c || used[8]==answer_c  );
		 used[i]=answer_c;
		 i+=1; 

		 answer= answer_a*100+answer_b*10+answer_c;
		 give_guess(answer, &num_a, &num_b);
		 state = 50;
		 break;

	case 51:

		 answer_b=second[1];
		 answer_c=second[2];

		 do
		 answer_a=rand()%9+1;
		 while
		 (used[0]==answer_a || used[1]==answer_a || used[2]==answer_a || used[3]==answer_a || used[4]==answer_a || used[5]==answer_a || used[6]==answer_a || used[7]==answer_a || used[8]==answer_a  );
		 used[i]=answer_a;
		 i+=1;			 

		 answer= answer_a*100+answer_b*10+answer_c;
		 give_guess(answer, &num_a, &num_b);
		 state = 51;
		 break;

	case 52:

		 answer_b=first[1];
		 answer_c=first[2];		 

		 answer= answer_c*100+answer_b*10+answer_a;
		 give_guess(answer, &num_a, &num_b);

		 if (num_a == 1 && num_b == 0){
				 state = 53;}		 
		 else {
				 state = 54;}		 
		 break;

	case 53:

		 answer_c=second[2];
		 
		 do
		 answer_a=rand()%9+1;
		 while
		 (used[0]==answer_a || used[1]==answer_a || used[2]==answer_a || used[3]==answer_a || used[4]==answer_a || used[5]==answer_a || used[6]==answer_a || used[7]==answer_a || used[8]==answer_a  );
		 used[i]=answer_a;
		 i+=1;

		 answer= answer_a*100+answer_b*10+answer_c;
		 give_guess(answer, &num_a, &num_b);
		 state = 53;	 
		 break;

	case 54:

	
		answer_b=second[1];
		 
		do
		answer_a=rand()%9+1;
		while
		(used[0]==answer_a || used[1]==answer_a || used[2]==answer_a || used[3]==answer_a || used[4]==answer_a || used[5]==answer_a || used[6]==answer_a || used[7]==answer_a || used[8]==answer_a  );
		used[i]=answer_a;
		i+=1;

		answer= answer_a*100+answer_b*10+answer_c;
		give_guess(answer, &num_a, &num_b);
		state = 53;	 
		break;

	case 55:

		answer_c=first[2];
		
		answer= answer_a*100+answer_b*10+answer_c;
		give_guess(answer, &num_a, &num_b);

		if (num_a == 1 && num_b == 0){
				 state = 56;}		 
		else if (num_a == 1 && num_b == 1){
		    	 state = 59;}
	    else if (num_a == 0 && num_b == 1){  
				 state = 60;}
		else{
			     state = 63;}
		break;

	case 56:

		answer_b=second[1];
		answer_c=first[1];

		answer= answer_a*100+answer_b*10+answer_c;
		give_guess(answer, &num_a, &num_b);

	    if (num_a == 2 && num_b == 0){
				 state = 57;}		 
		else{
		    	 state = 58;}
		break;

	case 57:

	
		do
		answer_a=rand()%9+1;
		while
		(used[0]==answer_a || used[1]==answer_a || used[2]==answer_a || used[3]==answer_a || used[4]==answer_a || used[5]==answer_a || used[6]==answer_a || used[7]==answer_a || used[8]==answer_a  );
		used[i]=answer_a;
		i+=1;

		answer= answer_a*100+answer_b*10+answer_c;
		give_guess(answer, &num_a, &num_b);
		state=57;
		break;

	case 58:

	
		do
		answer_a=rand()%9+1;
		while
		(used[0]==answer_a || used[1]==answer_a || used[2]==answer_a || used[3]==answer_a || used[4]==answer_a || used[5]==answer_a || used[6]==answer_a || used[7]==answer_a || used[8]==answer_a  );
		used[i]=answer_a;
		i+=1;

		answer= answer_b*100+answer_b*10+answer_a;
		give_guess(answer, &num_a, &num_b);
		state=58;
		break;

		
	case 59:

		answer_b=second[1];
		answer_c=first[2];

		do
		answer_a=rand()%9+1;
		while
		(used[0]==answer_a || used[1]==answer_a || used[2]==answer_a || used[3]==answer_a || used[4]==answer_a || used[5]==answer_a || used[6]==answer_a || used[7]==answer_a || used[8]==answer_a  );
		used[i]=answer_a;
		i+=1;

		answer= answer_c*100+answer_b*10+answer_a;
		give_guess(answer, &num_a, &num_b);
     	state = 59;
		break;

   case 60:

		answer_b=first[2];
		answer_c=second[2];

		answer= answer_a*100+answer_b*10+answer_c;
		give_guess(answer, &num_a, &num_b);

	    if (num_a == 2 && num_b == 0){
				 state = 61;}		 
		else{
		    	 state = 62;}
		break;

	case 61:

		do
		answer_a=rand()%9+1;
		while
		(used[0]==answer_a || used[1]==answer_a || used[2]==answer_a || used[3]==answer_a || used[4]==answer_a || used[5]==answer_a || used[6]==answer_a || used[7]==answer_a || used[8]==answer_a  );
		used[i]=answer_a;
		i+=1;

		answer= answer_a*100+answer_b*10+answer_c;
		give_guess(answer, &num_a, &num_b);
		state=61;
		break;

	case 62:

	
		do
		answer_a=rand()%9+1;
		while
		(used[0]==answer_a || used[1]==answer_a || used[2]==answer_a || used[3]==answer_a || used[4]==answer_a || used[5]==answer_a || used[6]==answer_a || used[7]==answer_a || used[8]==answer_a  );
		used[i]=answer_a;
		i+=1;

		answer= answer_c*100+answer_b*10+answer_b;
		give_guess(answer, &num_a, &num_b);
		state=62;
		break;

   case 63:
	   
		answer_b=first[1];
		answer_c=second[2];

		do
		answer_a=rand()%9+1;
		while
		(used[0]==answer_a || used[1]==answer_a || used[2]==answer_a || used[3]==answer_a || used[4]==answer_a || used[5]==answer_a || used[6]==answer_a || used[7]==answer_a || used[8]==answer_a  );
		used[i]=answer_a;
		i+=1;

		answer= answer_b*100+answer_a*10+answer_c;
		give_guess(answer, &num_a, &num_b);
     	state = 59;
		break;	

    }

   return get_answer;
}

void give_guess(int answer, int *num_a, int *num_b)
{
   char s[5];
   
   printf("  q׬ %dAпJתGG", answer);
   scanf("%s",s);
   *num_a = s[0]-'0';
   *num_b = s[2]-'0';
}